#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <time.h>

const int mapWidth = 20;
const int mapHeight = 15;
const int blockWidth = 5;
const int blockHeight = 5;

struct Player { // Egy jtkos adatai
       int table[mapHeight][mapWidth];
       int block[blockWidth][blockHeight];
       int bx,by,bt; //block x y koordinataja s tpusa
       int nb; //kvetkez blokk tpusa
       int id;
       int score; //jtkos pontja
       int ox; //offset rtkek (eltoljuk jtkosonknt a tbljukat hogy ne egymsra rajzolja)
       int oy;
       short color;
};

// Az eredeti res plya (Lehet bele neheztsknt fix rszeket rakni)
int masterTable[mapHeight][mapWidth]=
{
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',178},
    {178,178,178,178,178,178,178,178,178,178,178,178,178,178,178,178,178,178,178,178}
};

//A blokk tpusok
int block1[blockWidth][blockHeight] = {
    {' ',' ',' ',' ',' '},
    {' ',' ',219,219,' '},
    {' ',' ',219,219,' '},
    {' ',' ',' ',' ',' '},
    {' ',' ',' ',' ',' '}
};

int block2[blockWidth][blockHeight] = {
    {' ',' ',219,' ',' '},
    {' ',' ',219,' ',' '},
    {' ',' ',219,' ',' '},
    {' ',' ',219,' ',' '},
    {' ',' ',' ',' ',' '}
};

int block3[blockWidth][blockHeight] = {
    {' ',' ',219,' ',' '},
    {' ',' ',219,' ',' '},
    {' ',' ',219,219,' '},
    {' ',' ',' ',' ',' '},
    {' ',' ',' ',' ',' '}
};

int block4[blockWidth][blockHeight] = {
    {' ',' ',' ',' ',' '},
    {' ',' ',219,' ',' '},
    {' ',219,219,219,' '},
    {' ',' ',' ',' ',' '},
    {' ',' ',' ',' ',' '}
};



/* Szveges kpernyn pozcionl */
void gotoxy(int x, int y) {
    HANDLE hConsoleOutput;
    COORD dwCursorPosition;
    
    dwCursorPosition.X = x;
    dwCursorPosition.Y = y;
    hConsoleOutput = GetStdHandle(STD_OUTPUT_HANDLE); 
    SetConsoleCursorPosition(hConsoleOutput,dwCursorPosition);
}

/* Szveges kperny adott pozcijn lv karakter kiolvassa */
char charAt(short x, short y){
	CONSOLE_SCREEN_BUFFER_INFO screenBufferInfo;
	HANDLE hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	if (!GetConsoleScreenBufferInfo(hStd, &screenBufferInfo))
		printf("GetConsoleScreenBufferInfo (%d)\n", GetLastError());
	char buf[2]; 
    COORD c = {x,y};
    DWORD num_read;
	if( !ReadConsoleOutputCharacter(hStd,(LPTSTR)buf,1,c,(LPDWORD)&num_read) )
		return ' ';
	return buf[0];
}

/* Belltja a rajzolsi sznt. 7 a default szrke */
void setColor(short color) {
     HANDLE hConsole;
     hConsole=GetStdHandle(STD_OUTPUT_HANDLE);
     SetConsoleTextAttribute(hConsole, color);
}

void addBlock(Player &p) {
     int y=(rand()%(mapHeight-11))+6;
     int x=rand()%(mapWidth-2)+1;
     int fx=0;
     
     int spaceCount=0;
     for (int i=0; i<mapWidth; i++) {
         if (p.table[y][i]==' ') { //lecsekkoljuk hogy a teljes y-adik sor tele van e
            spaceCount++;
            if (fx==0)
               fx=i;
         }
     }     
     if (spaceCount>4) //legalabb 5 lyuknak kell lennie hogy abba a sorba berakjon egy akadajt
        if (charAt(x+p.ox,y+p.oy)!= ' ')
           p.table[y][fx] = 219;
        else
           p.table[y][x] = 219;
}

/* Kirajzolja az adott jtkos tbljt */
void drawTable(Player p) {
     setColor(p.color);     
     for (int j=0; j<mapHeight; j++) {
         for (int i=0; i<mapWidth; i++) {
             if (charAt(i+p.ox,j+p.oy)!=p.table[j][i]) {
                gotoxy(i+p.ox,j+p.oy);
                printf("%c",p.table[j][i]);
             }
         }
     }
}

/* Egy blokkot rajzol ki */
void drawBlock(Player p) {
     setColor(p.color);
     for (int j=0; j<blockHeight; j++) {
         for (int i=0; i<blockWidth; i++) {
             if ((i+p.bx>=0)&&(i+p.bx<mapWidth)&&(j+p.by>=0)&&(j+p.by<mapHeight)) { //tlindexels ellen
                 gotoxy(i+p.bx+p.ox,j+p.by+p.oy);
                 if (p.block[j][i]!=' ')
                    printf("%c",p.block[j][i]);
             }
         }
     }
     gotoxy(0,0);
}

void deleteBlock(Player p) {
     for (int j=0; j<blockHeight; j++) {
         for (int i=0; i<blockWidth; i++) {
             if ((i+p.bx>=0)&&(i+p.bx<mapWidth)&&(j+p.by>=0)&&(j+p.by<mapHeight)) { //tlindexels ellen
                 gotoxy(i+p.bx+p.ox,j+p.by+p.oy);
                 if (p.block[j][i]!=' ')
                    printf("%c",' ');
             }
         }
     } 
}

/* A kvetkez blokkot rajzolja ki x,y-ra */
void drawNextBlock(Player p, int x, int y) {     
     setColor(p.color);
     for (int j=0; j<blockWidth; j++) {
         for (int i=0; i<blockHeight; i++) {             
                 gotoxy(i+x+p.ox,j+y+p.oy);
                 if (p.nb==0) printf("%c",block1[j][i]);
                 if (p.nb==1) printf("%c",block2[j][i]);
                 if (p.nb==2) printf("%c",block3[j][i]);
                 if (p.nb==3) printf("%c",block4[j][i]);
         }
     } 
}

/* Kirajzolja az adott jtkos tbljt aktulis s kvetkez blokkkjt, pontjt */
void drawWorld(Player p) {
     setColor(p.color);
     gotoxy(p.ox,mapHeight);
     printf("Score: %d",p.score);
     gotoxy(p.ox+mapWidth+1,0);
     printf("Next:\n");
     drawNextBlock(p,mapWidth+1,2);
     gotoxy(0,mapHeight);
}

/* j blokk generlsa*/
void newBlock(Player &p) {
     p.bx = 2;
     p.by = -3;
     p.bt = p.nb;
     p.nb = rand()%4;
     for (int j=0; j<blockWidth; j++) {
         for (int i=0; i<blockHeight; i++) {
             if (p.bt==0) p.block[j][i] = block1[j][i];
             if (p.bt==1) p.block[j][i] = block2[j][i];
             if (p.bt==2) p.block[j][i] = block3[j][i];
             if (p.bt==3) p.block[j][i] = block4[j][i];
         }
     }
}

/* tkzs detektls */
int collided(Player p) {
    for (int j=0; j<blockWidth; j++) {
         for (int i=0; i<blockHeight; i++) {
             if ((i+p.bx>=0)&&(i+p.bx<mapWidth)&&(j+p.by+1>=0)&&(j+p.by+1<mapHeight)) //tlindexels ellen
             if (p.block[j][i]!=' ' && p.table[j+p.by+1][i+p.bx]!=' ')
                return 1;
         }
    }
    return 0;
}

/* Fallal val tkzsdetektls */
int checkWallColl(Player p) {
    for (int j=0; j<blockWidth; j++) {
         for (int i=0; i<blockHeight; i++) {
             if ((i+p.bx>=0)&&(i+p.bx<mapWidth)&&(j+p.by+1>=0)&&(j+p.by+1<mapHeight)) //tlindexels ellen
             if (p.block[j][i]!=' ' && (i+p.bx==0 || i+p.bx==mapWidth-1))
                return 1;
         }
    }
    return 0;
}

/* Az aktulis blockkot rrakja(msolja) a tblra */
void placeBlock(Player &p) {
     for (int j=0; j<blockWidth; j++) {
         for (int i=0; i<blockHeight; i++) {
             if ((i+p.bx>=0)&&(i+p.bx<mapWidth)&&(j+p.by>=0)&&(j+p.by<mapHeight)) //tlindexels ellen
             if (p.block[j][i]!=' ')
                p.table[j+p.by][i+p.bx]=p.block[j][i];
         }
    }
}

/* Vget rt a jtk? */
int checkGameOver(Player p) {
    for (int j=1; j<mapWidth-1; j++) {
             if (p.table[0][j]!=' ')
                return 1;
    }
    return 0;
}

/* Forgatja a blockot */
void rotateBlock(Player &p) {
     int tmp[5][5];
      for (int j=0; j<blockWidth; j++) {
         for (int i=0; i<blockHeight; i++) {
             tmp[i][j]=p.block[4-j][i];
         }
      }
      for (int j=0; j<blockWidth; j++) {
         for (int i=0; i<blockHeight; i++) {
             p.block[j][i]=tmp[j][i];
         }
      }     
}

/* Lecsekkoljuk hogy van e teltett sor, amit trlni kell */
void checkLines(Player &p,Player &p1, Player &p2) {
     int full=1;
     int b=0;
     for (int j=0; j<mapHeight-2; j++) {
         full=1;
         for (int i=0; i<mapWidth; i++) {
             if (p.table[j][i]==' ') { //lecsekkoljuk hogy a teljes j-edik sor tele van e
                full=0;
                break;
             }
         }
         if (full==1) {
             for (int i=1; i<mapWidth-1; i++) {
                 p.table[j][i]=' ';
                 p.score++;
                 b=1;
             }
             for (int k=j; k>0; k--) {
                 for (int i=1; i<mapWidth-1; i++)
                     p.table[k][i] = p.table[k-1][i];
             }
         }
     }
     if (b==1)
        if (p.id==1) {
           addBlock(p2);
           drawTable(p2);
           drawWorld(p2);
           drawBlock(p2);
        } else {
           addBlock(p1);
           drawTable(p1);
           drawWorld(p1);
           drawBlock(p1);
        }
     drawTable(p);
}

/* Kezdllapotba lltjuk a jtkost */
void initPlayer(Player &p, int ox, int oy, int id, short color) {
     p.ox = ox;
     p.oy = oy;
     p.score = 0;
     p.nb = rand()%4;
     p.id = id;
     p.color = color;
     
     for (int j=0; j<mapWidth; j++) {
         for (int i=0; i<mapHeight; i++) {
             p.table[i][j] = masterTable[i][j];
         }
     }     
     
     newBlock(p);
}


/* Main fggvny */
main() {   
       srand( time(NULL) );
       long tick=0; // ezzel a vltozval lasstunk
       struct Player p1,p2;       
       initPlayer(p1,0,0,1,11);
       initPlayer(p2,30,0,2,12);
       
       int fps=0, sleep_value=1, last_time=time(NULL);

       drawTable(p1);
       drawTable(p2);
       
       
       
       while (1) {
             
           // forgats lekezelse
           if (tick%2==0) {
               if (GetAsyncKeyState(VK_UP)&&(p1.bt!=0)) { // a ngyzet blokkot ne lehessen forgatni
                  deleteBlock(p1);
                  rotateBlock(p1);
                  if (collided(p1)) { // ha az elforgatott elem beletkzne valamilyen falba, akkor visszaforgatjuk mintha mi sem trtnne :)
                     rotateBlock(p1);
                     rotateBlock(p1);
                     rotateBlock(p1);
                  }
                  drawBlock(p1);              
               }
               if (GetAsyncKeyState(87)&&(p2.bt!=0)) {//W // a ngyzet blokkot ne lehessen forgatni
                  deleteBlock(p2);
                  rotateBlock(p2);
                  if (collided(p2)) { // ha az elforgatott elem beletkzne valamilyen falba, akkor visszaforgatjuk mintha mi sem trtnne :)
                     rotateBlock(p2);
                     rotateBlock(p2);
                     rotateBlock(p2);
                  }    
                  drawBlock(p2);                 
               }
           }
           
           // Billenytk lekezelse
           //if (tick%4==0) {
           //PLAYER1
           if (GetAsyncKeyState(VK_LEFT)) {
                  deleteBlock(p1);
                  p1.bx--;
                  if (checkWallColl(p1)) //ha falba tkzne, akkor visszatoljuk mintha mi sem trtnt volna
                     p1.bx++;
                  if (collided(p1)) {
                     p1.bx++;
                  }
                  drawBlock(p1);
           }
           if (GetAsyncKeyState(VK_RIGHT)) {
                  deleteBlock(p1);
                  p1.bx++;
                  if (checkWallColl(p1)) //ha falba tkzne, akkor visszatoljuk mintha mi sem trtnt volna
                     p1.bx--;
                  if (collided(p1)) {
                     p1.bx--;
                  }
                  drawBlock(p1);
           }
           if (GetAsyncKeyState(VK_DOWN)) {
                  deleteBlock(p1);
                  p1.by++;
                  if (collided(p1)) { //csak addig mozgathatjuk lefel amg nem tkznk valamibe
                     p1.by--;
                     tick=50;
                  }
                  drawBlock(p1);             
           }
           
           //PLAYER2
           if (GetAsyncKeyState(65)) {
                  deleteBlock(p2);
                  p2.bx--;
                  if (checkWallColl(p2)) //ha falba tkzne, akkor visszatoljuk mintha mi sem trtnt volna
                     p2.bx++;
                  if (collided(p2)) {
                     p2.bx++;
                  }
                  drawBlock(p2);
           }
           if (GetAsyncKeyState(68)) {
                  deleteBlock(p2);                   
                  p2.bx++;
                  if (checkWallColl(p2)) //ha falba tkzne, akkor visszatoljuk mintha mi sem trtnt volna
                     p2.bx--;
                  if (collided(p2)) {
                     p2.bx--;
                  }
                  drawBlock(p2);
           }
           if (GetAsyncKeyState(83)) {
                  deleteBlock(p2);                   
                  p2.by++;
                  if (collided(p2)) { //csak addig mozgathatjuk lefel amg nem tkznk valamibe
                     p2.by--;
                     tick=50;
                  }
                  drawBlock(p2);             
           }
           //}
           
/*
           addBlock(p1);
           drawTable(p1);
*/
           
           if (tick%10==0) { //a blokk bizonyos idnknt lefel esik
               deleteBlock(p1);
               deleteBlock(p2);
               p1.by++;
               p2.by++;
               drawBlock(p1);
               drawWorld(p1);
               drawBlock(p2);
               drawWorld(p2);
           }
               
           if (tick%10==0) {
               drawWorld(p1);               
               if (collided(p1)) { //tkzik az aktulis blokk valamivel
                  placeBlock(p1); //belegetjk a blokkot a plyba
                  checkLines(p1,p1,p2); //ellenrizzk leraks utn hogy kell e sort trlni
                  if (checkGameOver(p1)) { //leellenrizzk hogy vge van e a jtknak
                      gotoxy(0,mapHeight+1);
                      printf("Game Over");
                      break;
                  }
                  newBlock(p1); //j blokkot generlunk
               }   
               drawWorld(p2);    
               if (collided(p2)) { //tkzik az aktulis blokk valamivel
                  placeBlock(p2); //belegetjk a blokkot a plyba
                  checkLines(p2,p1,p2); //ellenrizzk leraks utn hogy kell e sort trlni
                  if (checkGameOver(p2)) { //leellenrizzk hogy vge van e a jtknak
                      gotoxy(0,mapHeight+1);
                      printf("Game Over");
                      break;
                  }
                  newBlock(p2); //j blokkot generlunk
               }                           
           }
           
           //LASSITAS
           if (sleep_value>0)
           Sleep(sleep_value);
           tick++; 
           
           //FPS szmols
           fps++;
           setColor(7);
           if (time(NULL)-last_time>=1) {
              gotoxy(0,18);
              printf("%dFPS",fps);
              fps = 0;
              last_time = time(NULL);
           }
           if (fps>5) sleep_value++;
           if (fps<5) sleep_value--;
           gotoxy(1,19);
           printf("%d",sleep_value);
                     
           
           if (GetAsyncKeyState(VK_ESCAPE))
              break; //Kilps
       }
       
       printf("\nKilepeshez nyomjon ENTER-t");
       getchar();
}
